function factf(arg1,arg2,arg3,arg4)
%FACTF    Factorization of a transfer function (TFI).
%   FACTF,gi,gj - from TFI [FACTF('gi','gj') - from Matlab]
%   saves in gj the factorized form of gi. To improve numerical
%   robustness, selection of multiple roots is interactive.
%   If FACTF is called without arguments, gi and gj can be specified
%   in interactive mode.

% TFI Environment (A.Civolani & G.Marro) - 1994-96. Matlab5 version, 1997.

o=setstr(166); vv=[];
if nargin==0
 gi=input('\n   enter transfer function gi (input) : ','s');
 if isempty(gi), return, end
 if gi=='0', return, end
 if ~exist([gi,'.mat'])
  disp([' **** error: ',gi,'.mat does not exist']), return
 end
 gj=input('\n   enter transfer function gj (output) : ','s');
 if isempty(gj), return, end
 if gj=='0', return, end
elseif nargin>=2
 if ~exist([arg1,'.mat'])
  disp([' **** error: ',arg1,'.mat does not exist'])
  return
 else
  gi=arg1; gj=arg2;
 end
else
 disp(' **** error: not enough input arguments')
 return
end
eval(['load ',gi])
sn=size(Numc); sd=size(Denc);
Num=Numc; Den=Denc;
zz=[]; pp=[];
clc
tfg(gi)
fprintf('\n   You can factorize:\n\n   1) numerator')
fprintf('\n   2) denominator\n   3) numerator and denominator\n')
xx=0;
while ((xx~=1)&(xx~=2)&(xx~=3))
 xx=input('\n   enter your choice (return to skip) : ');
 if length(xx)==0
  return
 end
end
if xx~=2
 for i=1:sn(1)
  a=(find(Numc(i,:)~=0));
  r=roots(Numc(i,a(1):sn(2)));
  zz=[zz;r];
 end
 ss=1;
 if length(zz)==0, ss=0; end
 while ss==1
  clc, disp(' ')
  disp('   >>> Zeros <<<')
  disp(' ')
  zzz=1;
  for k=1:length(zz)
   if abs(imag(zz(k)))>10^(-4)
    fprintf(['  %4.f  ',o,'  %+4.4e    %+4.4e * j'],...
     k,real(zz(k)),imag(zz(k)))
    fprintf(['  ',o,'%4.f\n'],zzz)
   else
    fprintf(['  %4.f  ',o,'  %+4.4e                    '],k,real(zz(k)))
    fprintf(['  ',o,'%4.f\n'],zzz)
   end
  end
  tol=input('\n   specify the tolerance (default is 10^(-4)) : ');
  if isempty(tol)
   tol=10^(-4);
  end
  tol=abs(tol*1.01); [egv,mul]=makest(zz,tol,0);
% Rounds the eigenvalues
  for k=1:length(mul)
   if mul(k)>1
    pre=real(egv(k)); pim=imag(egv(k));
    if pre~=0
     tt=10^(8-round(log10(abs(pre))));
     pre=(round(abs(pre)*tt)/tt)*sign(pre);
    end
    if pim~=0
     tt=10^(8-round(log10(abs(pim))));
     pim=(round(abs(pim)*tt)/tt)*sign(pim);
    end
    egv(k)=pre+j*pim;
   end
  end
% Builds the conjugate eigenvalues
  ii=find(abs(imag(egv))>0);
  egv=[egv conj(egv(ii))];
  mul=[mul mul(ii)];
  disp(' ')
  disp('   >>> Zeros with multiplicities detected <<<')
  disp(' ')
  for k=1:length(egv)
   if abs(imag(egv(k)))>10^(-4)
    fprintf(['  %4.f  ',o,'  %+4.4e    %+4.4e * j'],k,...
     real(egv(k)),imag(egv(k)))
    fprintf(['  ',o,'%4.f\n'],mul(k))
   else
    fprintf(['  %4.f  ',o,'  %+4.4e                    '],k,real(egv(k)))
    fprintf(['  ',o,'%4.f\n'],mul(k))
   end
  end
  kzz=0;
  while kzz==0;
   kzz=1;
   ss=input('\n   do you want to change the tolerance (1/0) ? : ');
   if isempty(ss), ss=0; kzz=0; end;
   rop=((ss~=1)&(ss~=0)); if rop, kzz=0; end
  end
 end % while ss==1
 egvz=egv;
 mulz=mul;
 for i1=1:length(mulz)
  for i2=1:mulz(i1)
   if imag(egvz(i1))==0
    vv=[vv;egvz(i1)];
   elseif imag(egvz(i1))<0
    vv=[vv;egvz(i1);conj(egvz(i1))];
   end
  end
 end
 z=vv;
 Num=[]; ii=1;
 while ii<=length(z)
  sn=size(Num);
  if abs(imag(z(ii)))>10^(-4)
   nn=poly([z(ii),real(z(ii))-j*imag(z(ii))]);
   qq=find(z==(real(z(ii))-j*imag(z(ii))));
   if length(qq)~=0, z(qq(1))=[]; end
   Num=[zeros(sn(1),length(nn)-sn(2)),Num;nn];
  else
   Num=[Num;zeros(1,sn(2)-2),poly(z(ii))];
  end
  ii=ii+1;
 end
end
if xx~=1
 for i=1:sd(1)
  a=(find(Denc(i,:)~=0));
  r=roots(Denc(i,a(1):sd(2)));
  pp=[pp;r];
 end
 ss=1;
 if length(pp)==0, ss=0; end
 while ss==1
  clc, disp(' ')
  disp('   >>> Poles <<<')
  disp(' ')
  ppp=1;
  for k=1:length(pp)
   if abs(imag(pp(k)))>10^(-4)
    fprintf(['  %4.f  ',o,'  %+4.4e    %+4.4e * j'],...
     k,real(pp(k)),imag(pp(k)))
    fprintf(['  ',o,'%4.f\n'],ppp)
   else
    fprintf(['  %4.f  ',o,'  %+4.4e                    '],k,real(pp(k)))
    fprintf(['  ',o,'%4.f\n'],ppp)
   end
  end % for
  tol=input('\n   specify the tolerance (default is 10^(-4)) : ');
  if isempty(tol)
   tol=10^(-4);
  end
  tol=abs(tol*1.01); [egv,mul]=makest(pp,tol,0);
% Rounds the eigenvalues
  for k=1:length(mul)
   if mul(k)>1
    pre=real(egv(k)); pim=imag(egv(k));
    if pre~=0
     tt=10^(8-round(log10(abs(pre))));
     pre=(round(abs(pre)*tt)/tt)*sign(pre);
    end
    if pim~=0
     tt=10^(8-round(log10(abs(pim))));
     pim=(round(abs(pim)*tt)/tt)*sign(pim);
    end
    egv(k)=pre+j*pim;
   end
  end
% Builds the conjugate eigenvalues
  ii=find(abs(imag(egv))>0);
  egv=[egv conj(egv(ii))];
  mul=[mul mul(ii)];
  disp(' ')
  disp('   >>> Poles with multiplicities detected <<<')
  disp(' ')
  for k=1:length(egv)
   if abs(imag(egv(k)))>10^(-4)
    fprintf(['  %4.f  ',o,'  %+4.4e    %+4.4e * j'],...
      k,real(egv(k)),imag(egv(k)))
    fprintf(['  ',o,'%4.f\n'],mul(k))
   else
    fprintf(['  %4.f  ',o,'  %+4.4e                    '],k,real(egv(k)))
    fprintf(['  ',o,'%4.f\n'],mul(k))
   end
  end % for
  kzz=0;
  while kzz==0;
   kzz=1;
   ss=input('\n   do you want to change the tolerance (1/0) ? : ');
   if length(ss)==0; ss=0; kzz=0; end;
   rop=((ss~=1)&(ss~=0)); if rop; kzz=0; end;
  end
 end % while ss==1
 egvp=egv;
 mulp=mul;
 vv=[];
 for i1=1:length(mulp)
  for i2=1:mulp(i1)
   if imag(egvp(i1))==0
    vv=[vv;egvp(i1)];
   elseif imag(egvp(i1))<0
    vv=[vv;egvp(i1);conj(egvp(i1))];
   end
  end
 end
 p=vv;
 Den=[]; ii=1;
 while ii<=length(p)
  sd=size(Den);
  if abs(imag(p(ii)))>10^(-4)
   dd=poly([p(ii),real(p(ii))-j*imag(p(ii))]);
   qq=find(p==(real(p(ii))-j*imag(p(ii))));
   if length(qq)~=0, p(qq(1))=[]; end
   Den=[zeros(sd(1),length(dd)-sd(2)),Den;dd];
  else
   Den=[Den;zeros(1,sd(2)-2),poly(p(ii))];
  end
  ii=ii+1;
 end
end
clc
tfg(gi)
aa=stf(Num,Den,kc,strc,gj);
if aa==1, tfg(gj), end
% --- last line of factf ---
