function firtf(arg1,arg2,arg3,arg4)
%FIRTF	  Defines a FIR - finite-impulse-response system (TFI).
%    FIRTF,gi,gj - from TFI [FIRTF('gi','gj') - from Matlab] cretes a FIR
%    gj corresponding to transfer function gi,
%    The FIR memory is given in interactive mode.
%    If FIRTF is called without arguments, transfer functions gi and gj
%    can be specified in interactive mode.

% TFI Environment (A.Civolani & G.Marro) - 1994-96. Matlab5 version, 1997.

if nargin==0
 flg=0;
 while flg==0
  gi=input('\n   enter transfer function gi (input) : ','s');
  if ~isempty(gi)
   if gi=='0', return, end
   if ~exist([gi,'.mat'])
    disp([' **** error: ',gi,'.mat does not exist'])
   else
    flg=1;
   end
  end
 end
 while flg==1
  gj=input('\n   enter transfer function gj (output) : ','s');
  if ~isempty(gj)
   if gj=='0', return, end
   flg=2;
  end
 end
elseif nargin>=2
 if ~exist([arg1,'.mat'])
  disp([' **** error: ',arg1,'.mat does not exist']), return
 else
  gi=arg1; gj=arg2;
 end
else
 disp(' **** error: not enough input arguments'), return
end
[num,den,str]=exportf(gi,1); % if isempty(den), return, end
if str=='s'
 disp(' **** error: continuous-time system'), return
end
tfg(gi)
N=input('\n   enter the FIR memory : ');
k1=abs(N);
%
k0=0; k=k0:1:k1; nk=length(k);
%
ttt=[zeros(1,length(den)-length(num)),num];
y=filter(ttt,den,[1,zeros(1,nk-1)]);
%
num1=y;
den1=[1,zeros(1,k1)];
aa=importf(num1,den1,gj,1);
if aa==1, tfg(gj), end
% --- last line of firtf ---
