function prninfo(flag)
%PRNINFO  Auxiliary file for information on design of regulators.

% TFI Environment (A.Civolani & G.Marro) - 1994-96. Matlab5 version, 1997.

[vcol1,vcol2,repco,repcos]=coltbl;
ms2='   **** press any key to continue';
%
if flag==1 % information on pidnich
%
 clc
 disp(' '), disp(' ')
 disp('   THE TRANSFER FUNCTIONS OF THE REGULATORS')
 disp(' ')
 disp(' ')
 disp('   1 - PD :    gc(s) = Kc (1 + Td s) ;')
 disp(' ')
 disp(' ')
 disp('                                1')
 disp('   2 - PI :    gc(s) = Kc (1 + ----) ;')
 disp('                               Ti s')
 disp(' ')
 disp(' ')
 disp('                                1')
 disp('   3 - PID :   gc(s) = Kc (1 + ---- + Td s) .')
 disp('                               Ti s')
 disp(' '), disp(' ')
 disp(ms2), pause
 clc
 disp(' '), disp(' ')
 disp('   THE DESIGN WITH THE INVERSION FORMULAE')
 disp(' ')
 disp('   The PD, PI or PID regulators are designed with the following steps:')
 disp(' ')
 disp('   1 - Select with the mouse a point "TO" on the Nichols diagram')
 disp('       plane, corresponding to good phase or gain margin:')
 disp('       let M2, phi2 be the corresponding gain and phase.')
 disp(' ')
 disp('   2 - Select with the mouse a point "FROM" on the Nichols diagram:')
 disp('       let M1, phi1 be the corresponding gain and phase, and omega0')
 disp('       the corresponding angular frequency on the Nichols plot.')
 disp(' ')
 disp('   NOTE: the second selection is restricted to belong to a suitable')
 disp('   domain D, depending on the first one.')
 disp(' ')
 disp('   Let M:=M2/M1, phi:=phi2-phi1 be the absolute value and phase')
 disp('   angle of the vector FROM-TO.')
 disp(' '), disp(' ')
 disp(ms2), pause
 clc
 disp(' '), disp(' ')
 disp('   1 - PD')
 disp(' ')
 disp('   The domain D to which M and phi must belong is: ')
 disp(' ')
 disp('          0 <= phi< pi/2 .')
 disp(' ')
 disp('   The inversion formulae of the PD regulator are:')
 disp(' ')
 disp('          Kc = M cos(phi) ,  (omega Td) = tan(phi) ;')
 disp(' ')
 disp('   Td is derived as (omega Td)/omega0.')
 disp(' '), disp(' ')
 disp(ms2), pause
 clc
 disp(' '), disp(' ')
 disp('   2 - PI')
 disp(' ')
 disp('   The domain D to which M and phi must belong is: ')
 disp(' ')
 disp('          -pi/2 < phi<= 0 .')
 disp(' ')
 disp('   The inversion formulae of the PI regulator are:')
 disp(' ')
 disp('          Kc = M cos(phi) ,  (omega Ti) = -1/tan(phi) ;')
 disp(' ')
 disp('   Ti is derived as (omega Ti)/omega0.')
 disp(' '), disp(' ')
 disp(ms2), pause
 clc
 disp(' '), disp(' ')
 disp('   3 - PID')
 disp(' ')
 disp('   The domain D to which M and phi must belong is: ')
 disp(' ')
 disp('          -pi/2 < phi< pi/2 .')
 disp(' ')
 disp('   The inversion formulae of the PID regulator are:')
 disp(' ')
 disp('          Kc = M cos(phi) ,')
 disp(' ')
 disp('                       1 Ti')
 disp('          (omega Ti) = - -- [tan(phi)+sqrt(tan(phi)^2+4 (Td/Ti)] ;')
 disp('                       2 Td')
 disp(' ')
 disp('   Ti is derived as (omega Ti)/omega0.')
 disp(' ')
 disp('   NOTE: it is necessary to specify the ratio Ti/Td, as a degree')
 disp('         of freedom in the design.')
 disp(' ')
 disp(ms2), pause
%
elseif flag==2 % information on regnich
%
 nfig=gcf; clf, ordf(3), nfigs=int2str(nfig);
 clc
 disp(' '), disp(' ')
 disp('   THE TRANSFER FUNCTIONS OF THE COMPENSATORS')
 disp(' ')
 disp('   1 - LEAD')
 disp(' ')
 disp('                    1 + tau s')
 disp('          gc(s) = --------------- ;')
 disp('                  1 + alpha tau s')
 disp(' ')
 disp(' ')
 disp('   2 - LAG')
 disp(' ')
 disp('                  1 + alpha tau s')
 disp('          gc(s) = --------------- .')
 disp('                    1 + tau s')
 disp(' '), disp(' ')
 disp(ms2), pause
 clc
 disp(' '), disp(' ')
 disp('   THE DESIGN WITH THE INVERSION FORMULAE')
 disp(' ')
 disp('   The lead or lag compensator are designed with the following steps:')
 disp(' ')
 disp('   1 - Select with the mouse a point "TO" on the Nichols diagram')
 disp('       plane, corresponding to good phase or gain margin:')
 disp('       let M2, phi2 be the corresponding gain and phase.')
 disp(' ')
 disp('   2 - Select with the mouse a point "FROM" on the Nichols diagram:')
 disp('       let M1, phi1 be the corresponding gain and phase, and omega0')
 disp('       the corresponding angular frequency on the Nichols plot.')
 disp(' ')
 disp('   NOTE: the second selection is restricted to belong to a suitable')
 disp('   domain D, depending on the first one.')
 disp(' ')
 disp('   Let M:=M2/M1, phi:=phi2-phi1 be the absolute value and phase')
 disp('   angle of the vector FROM-TO.')
 disp(' '), disp(' ')
 disp(ms2), pause
 clc
 disp(' '), disp(' ')
 disp('   1 - LEAD')
 disp(' ')
 disp('   The domain D to which M and phi must belong is: ')
 disp(' ')
 disp('          M>1, phi<=arcos(1/M) .')
 disp(' ')
 disp('   The inversion formulae of the lead compensator are:')
 disp(' ')
 disp('                  M cos(phi) - 1                  M - cos(phi)')
 disp('          alpha = -------------- ,  (omega tau) = ------------ ;')
 disp('                  M [M-cos(phi)]                    sin(phi)')
 disp(' ')
 disp('   tau is derived as (omega tau)/omega0.')
 disp(' '), disp(' ')
 disp(ms2), pause
 clc
 disp(' '), disp(' ')
 disp('   2 - LAG')
 disp(' ')
 disp('   The domain D to which M and phi must belong is: ')
 disp(' ')
 disp('          M<1, phi>=-arcos(M) .')
 disp(' ')
 disp('   The inversion formulae of the lag compensator are:')
 disp(' ')
 disp('                  M [cos(phi)-M]                  1 - M cos(phi)')
 disp('          alpha = -------------- ,  (omega tau) = -------------- ;')
 disp('                  1 - M cos(phi)                   M sin(-phi)')
 disp(' ')
 disp('   tau is derived as (omega tau)/omega0.')
 disp(' '), disp(' ')
 disp(ms2), pause
 clc
 disp(' '), disp(' ')
 disp('   3 - GAIN')
 disp(' ')
 disp('   In this case only the point "TO" is selected with the mouse;')
 disp('   the point "FROM" is automatically determined as the point on the')
 disp('   Nichols plot on the same vertical line, that must exist and be')
 disp('   unique. Selection defines the gain factor:')
 disp(' ')
 disp('          Kc = M2/M1 ;')
 disp(' ')
 disp('   this is included in the compensator.')
 disp(' '), disp(' ')
 disp(ms2), pause
 clc
 disp(' '), disp(' ')
 disp('   SOME NICHOLS PLOTS OF THE LEAD COMPENSATOR')
 disp(' ')
 disp('   The following figure shows some Nichols plots of the LEAD compensator.')
 disp('   Those of the LAG compensator are symmetric with respect to the origin.')
 cc1=deblank(repcos(1,:)); cc2=deblank(repcos(2,:));
 mess=['   Colors: solid ',cc1,' = constant alpha, dashed ',cc2,...
 ' = constant (omega tau).'];
 disp(mess)
 disp('   Graduation is both in true values and in db (in brackets).')
 disp(' ')
 disp(ms2), pause
 j=sqrt(-1);
 %alpha=logspace(0,-3,25);
 alpha=logspace(0,-3,13);
 alpha=alpha(2:length(alpha)); alpha=[alpha,0];
 %alpha=[.1,.01,.001];
 nal=length(alpha);
 nt=2000;
 ot=logspace(-3,6,nt);
 VV=[0,90,0,60]; ddx=(VV(2)-VV(1))/100; ddy=(VV(4)-VV(3))/100;
 vv=zeros(1,nt);
 plot(0,0,'Color',vcol1(8,:),'LineStyle','none','Marker','.')
 axis(VV), set(gca,'PlotBoxAspectRatioMode','manual')
 set(gca,'PlotBoxAspectRatio',[1.1,1,1])
 xtick=0:5:90; set(gca,'Xtick',xtick)
 ytick=0:5:60; set(gca,'Ytick',ytick)
 grid
 hold on
 for hh=1:nal
  for kk=1:nt
   vv(kk)=(1+j*ot(kk))/(1+j*alpha(hh)*ot(kk));
  end
  M=20*log10(abs(vv)); phi=angle(vv)*180/pi;
  plot(phi,M,'Color',vcol1(1,:),'LineStyle','-')
  if alpha(hh)~=0
   aa=alpha(hh);
   ee=floor(log10(aa)); ff=10^ee; aadb=20*log10(aa);
   mess=sprintf('%.2g',aa/ff); mess=[mess,'e',int2str(ee)];
   mess1=sprintf('%.2g',aadb); mess=[mess,' (',mess1,')'];
   ii1=find(M<=VV(4)); mt=ii1(length(ii1));
   mx=phi(mt)+4*ddx; my=M(mt)-2.6*ddy;
   text(mx,my,mess,'FontSize',8,'FontWeight','bold','Interpreter','none')
  else
   mess='\alpha=0';
   mx=VV(2)-5*ddx; my=VV(4)-5*ddy;
   text(mx,my,mess,'FontSize',8,'FontWeight','bold','Interpreter','Tex')
  end
 end
 ott=logspace(0,4,17);
 ottl=length(ott);
 nt=400;
 alt=logspace(2,-6,nt);
 vv=zeros(1,nt);
 for hh=1:ottl
  for kk=1:nt
   vv(kk)=(1+j*ott(hh))/(1+j*alt(kk)*ott(hh));
  end
  M=20*log10(abs(vv)); phi=angle(vv)*180/pi;
  plot(phi,M,'Color',vcol1(2,:),'LineStyle','--')
  aa=ott(hh)+10^(-8);
  ee=round(floor(log10(aa))); ff=10^ee; aadb=20*log10(aa);
  if aadb<10^(-4); aadb=0; end
  mess=sprintf('%.2g',aa/ff); if ee~=0, mess=[mess,'e',int2str(ee)]; end
  mess1=sprintf('%.2g',aadb); mess=[mess,' (',mess1,')'];
  ii1=find(M<=VV(4)); mt=ii1(length(ii1));
  if (aa-10^(-4))<1000
   mx=phi(mt)-28*ddx; my=M(mt)-2.6*ddy;
  else
   mx=phi(mt)+2*ddx; my=VV(4)+2.6*ddy;
   if hh==16, mx=mx-3*ddx; end
   if hh==17, mx=mx-8*ddx; end
  end
  if hh==1, mx=mx-6*ddx; my=my-.5*ddy; end
  if hh==2, mx=mx-2.5*ddx; my=my-.5*ddy; end
  text(mx,my,mess,'FontSize',8,'FontWeight','bold','Interpreter','none')
 end
 xlabel('Nichols diagrams of lead compensators',...
 'Color',vcol2(7,:),'FontWeight','normal')
 ha=text(-.1,.84,'<<   alpha','Units','normalized','Rotation',90);
 set(ha,'Color',vcol2(1,:),'FontWeight','normal','Interpreter','none')
 ha=text(1.05,.5,'<<   omega tau','Units','normalized','Rotation',-90);
 set(ha,'Color',vcol2(2,:),'FontWeight','normal','Interpreter','none')
 hold off
 uimenu(nfig,'Label','Grid on/off','Callback','grid');
 figure(nfig)
 xyx=input(['\n   **** figure ',nfigs,' **** '],'s');
%
elseif flag==3 % information on lagc
%
 nfig=gcf; clf, ordf(3), nfigs=int2str(nfig);
 wfont='normal'; % wfont='bold';
 clc
 disp(' '), disp(' ')
 disp('   LAG COMPENSATOR DESIGN')
 disp(' ')
 disp('                              1 + alpha tau s')
 disp('   Transfer function: gc(s) = --------------- .')
 disp('                                 1 + tau s')
 disp(' ')
 disp('   Mid-band frequency: om_0 = 1/(tau sqrt(alpha)) .')
 disp(' ')
 disp('                                                 1 - alpha')
 disp('   Mid-band (maximum) phase lag: phi_0 = -arcsin --------- .')
 disp('                                                 1 + alpha')
 disp(' ')
 disp(' ')
 disp('   **** press any key to see the Bode diagrams ');
 pause
 VV=[10^(-2),10^2,-60,20]; axis(VV)
 om1=VV(1); om2=VV(2); phi1=-90; phi2=30; alpha=.1; omc=1;
 num1=[sqrt(alpha)/omc,1]; den1=[1/(omc*sqrt(alpha)),1];
 [z1,p1,k1]=tozpk(num1,den1);
 [pho1,pho2,mag,phi,om]=bodec(z1,p1,k1,om1,om2,repco(2),phi2,phi1);
 VV=axis; axis(VV), hold on
 [oa,ga]=asymga(z1,p1,k1,om1,om2);
 semilogx(oa,20*log10(ga),'Color',vcol1(2,:),'LineStyle','-')
 phi1=pho1; phi2=pho2;
%
 alphacc=[.005 .01 .02 .05 .2 .5];
 for kk=1:6
  num1=[sqrt(alphacc(kk))/omc,1]; den1=[1/(omc*sqrt(alphacc(kk))),1];
  [z1,p1,k1]=tozpk(num1,den1);
  [pho1,pho2,mag,phi,om]=bodec(z1,p1,k1,om1,om2,repco(1),phi1,phi2);
 end
 mess='frequency responses of some lag compensators';
 ha=text(.02,.96,mess,'Units','normalized');
 set(ha,'FontWeight',wfont,'Interpreter','none')
 mess='mid-band frequency: 1 rad/sec for all';
 ha=text(.02,.91,mess,'Units','normalized');
 set(ha,'FontWeight',wfont,'Interpreter','none')
 mess='alpha=0.1';
 ha=text(.02,.86,mess,'Units','normalized');
 set(ha,'FontWeight',wfont,'Color',vcol2(2,:),'Interpreter','none')
 mess='alpha=0.005, 0.01, 0.02, 0.05, 0.2, 0.5';
 ha=text(.02,.81,mess,'Units','normalized');
 set(ha,'FontWeight',wfont,'Color',vcol2(1,:),'Interpreter','none')
 uimenu(nfig,'Label','Grid on/off','Callback','grid');
 axis(VV), figure(nfig)
 xyx=input(['\n   **** figure ',nfigs,' **** '],'s');
 clc
 disp(' ')
 disp('   DESIGN OF THE REFERENCE LAG COMPENSATOR:')
 disp(' ')
 disp('   1 - the phase margin phm and corresponding angular frequency omm')
 disp('       of the controlled system are computed and displayed;')
 disp('   2 - the required phase margin phd is entered by the user, and the')
 disp('       value of gain reduction alpha_0 which gives this phase margin')
 disp('       and the corresponding angular frequency om_0 are computed and')
 disp('       displayed;')
 disp('   3 - the value alpha = (alpha_0)/2 is chosen for the reference lag')
 disp('       compensator;')
 disp('   4 - tau is varied between 100/(om_0*alpha_0) and')
 disp('       1/(10*om_0*alpha_0) (400 steps) and the value corresponding to')
 disp('       the overall system phase margin closest to phd is selected.')
 disp(' ')
 disp('   Interactive adjustment of alpha is possible.')
 disp(' ')
%
elseif flag==4 % information on leadc
%
 nfig=gcf; clf, ordf(3), nfigs=int2str(nfig);
 wfont='normal'; % wfont='bold';
 clc
 disp(' '), disp(' ')
 disp('   LEAD COMPENSATOR DESIGN')
 disp(' ')
 disp('                                 1 + tau s')
 disp('   Transfer function: gc(s) = --------------- .')
 disp('                              1 + alpha tau s')
 disp(' ')
 disp('   Mid-band frequency: om_0 = 1/(tau sqrt(alpha)) .')
 disp(' ')
 disp('                                                 1 - alpha')
 disp('   Mid-band (maximum) phase lead: phi_0 = arcsin --------- .')
 disp('                                                 1 + alpha')
 disp(' ')
 disp(' ')
 disp('   **** press any key to see the Bode diagrams ');
 pause
 VV=[10^(-2),10^2,-20,60]; axis(VV)
 om1=VV(1); om2=VV(2); phi1=-30; phi2=90; alpha=.1; omc=1;
 num1=[1/(omc*sqrt(alpha)),1]; den1=[sqrt(alpha)/omc,1];
 [z1,p1,k1]=tozpk(num1,den1);
 [pho1,pho2,mag,phi,om]=bodec(z1,p1,k1,om1,om2,repco(2),phi2,phi1);
 VV=axis; axis(VV), hold on
 [oa,ga]=asymga(z1,p1,k1,om1,om2);
 semilogx(oa,20*log10(ga),'Color',vcol1(2,:),'LineStyle','-')
 phi1=pho1; phi2=pho2;
%
 alphacc=[.005 .01 .02 .05 .2 .5];
 for kk=1:6
  num1=[1/(omc*sqrt(alphacc(kk))),1]; den1=[sqrt(alphacc(kk))/omc,1];
  [z1,p1,k1]=tozpk(num1,den1);
  [pho1,pho2,mag,phi,om]=bodec(z1,p1,k1,om1,om2,repco(1),phi1,phi2);
 end
 mess='frequency responses of some lead compensators';
 ha=text(.02,.19,mess,'Units','normalized');
 set(ha,'FontWeight',wfont,'Interpreter','none')
 mess='mid-band frequency: 1 rad/sec for all';
 ha=text(.02,.14,mess,'Units','normalized');
 set(ha,'FontWeight',wfont,'Interpreter','none')
 mess='alpha=0.1';
 ha=text(.02,.09,mess,'Units','normalized');
 set(ha,'FontWeight',wfont,'Color',vcol2(2,:),'Interpreter','none')
 mess='alpha=0.005, 0.01, 0.02, 0.05, 0.2, 0.5';
 ha=text(.02,.04,mess,'Units','normalized');
 set(ha,'FontWeight',wfont,'Color',vcol2(1,:),'Interpreter','none')
 uimenu(nfig,'Label','Grid on/off','Callback','grid');
 axis(VV), figure(nfig)
 xyx=input(['\n   **** figure ',nfigs,' **** '],'s');
 clc
 disp(' ')
 disp('   DESIGN OF THE REFERENCE LEAD COMPENSATOR:')
 disp(' ')
 disp('   1 - the phase margin phm and corresponding angular frequency omm')
 disp('       of the controlled system are computed and displayed;')
 disp('   2 - the required phase margin phd is entered by the user, and the')
 disp('       value alpha_0 corresponding to mid-band phase lead equal to')
 disp('       phd-phm, is computed  and displayed;')
 disp('   3 - the value alpha = (alpha_0)/2 is chosen for the reference lead')
 disp('       compensator;')
 disp('   4 - tau is varied between sqrt(alpha)/omm and 1/(omm*sqrt(alpha))')
 disp('       (100 steps) and the value corresponding to the overall system')
 disp('       maximum phase margin is selected.')
 disp(' ')
 disp('   Interactive adjustment of alpha is possible.')
 disp(' ')
%
elseif flag==5 % information on pidc
%
 nfig=gcf; clf, ordf(3), nfigs=int2str(nfig);
 wfont='normal'; % wfont='bold';
 clc
 disp(' '), disp(' ')
 disp('   PROPORTIONAL-INTEGRAL-DERIVATIVE (PID) REGULATOR DESIGN')
 disp(' ')
 disp('                                        1')
 disp('   Transfer function: gc(s) = Kc ( 1 + ---- + Td s ) .')
 disp('                                       Ti s')
 disp(' ')
 disp('   Gain (proportional sensitivity) : Kc .')
 disp(' ')
 disp('   Mid-band frequency: om0 : 1/sqrt(Ti Td) .')
 disp(' ')
 disp('   Time constant ratio rho : Ti/Td .')
 disp(' ')
 disp('   Derivative action taken from the feedback path is equivalent to')
 disp('   splitting the regulator into two units:')
 disp('                                                1')
 disp('   a PI feedforward unit  : gcd(s) = Kc ( 1 + ---- ) ;')
 disp('                                              Ti s')
 disp(' ')
 disp('                                     Ti Td s^2 + Ti s + 1')
 disp('   a feedback compensator : gcf(s) = -------------------- .')
 disp('                                          1 + Ti s')
 disp(' ')
 disp('   **** press any key to see the Bode diagrams ');
 pause
 VV=[10^(-3),10^3,-40,40]; axis(VV)
 om1=VV(1); om2=VV(2); phi1=-120; phi2=90;
 kc=1; omc=1; rho=4; taui=sqrt(rho)/omc; taud=1/(sqrt(rho)*omc);
 num1=[taui*taud,taui,1]; den1=[taui,0]; [z1,p1,k1]=tozpk(num1,den1);
 [pho1,pho2,mag,phi,om]=bodec(z1,p1,k1,om1,om2,repco(2),phi2,phi1);
 VV=axis; axis(VV), hold on
 phi1=pho1; phi2=pho2; om1=10^VV(1); om2=10^VV(2);
%
 rhocc=[10000,1000,100,10,1];
 for kk=1:5
  kc=1; omc=1; taui=sqrt(rhocc(kk))/omc; taud=1/(sqrt(rhocc(kk))*omc);
  num1=kc*[taui*taud,taui,1]; den1=[taui,0]; [z1,p1,k1]=tozpk(num1,den1);
  [pho1,pho2,mag,phi,om]=bodec(z1,p1,k1,om1,om2,repco(1),phi1,phi2);
 end
 mess='frequency responses of some PID regulators';
 ha=text(.02,.19,mess,'Units','normalized');
 set(ha,'FontWeight',wfont,'Interpreter','none')
 mess='mid-band frequency: 1 rad/sec for all';
 ha=text(.02,.14,mess,'Units','normalized');
 set(ha,'FontWeight',wfont,'Interpreter','none')
 mess='Kc=1, Ti=2, Td=1/2';
 ha=text(.02,.09,mess,'Units','normalized');
 set(ha,'FontWeight',wfont,'Color',vcol2(2,:),'Interpreter','none')
 mess='Kc=1, Ti=10^k, k=0,1,2,3,4, Td=1/Ti';
 ha=text(.02,.04,mess,'Units','normalized');
 set(ha,'FontWeight',wfont,'Color',vcol2(1,:),'Interpreter','none')
 uimenu(nfig,'Label','Grid on/off','Callback','grid');
 axis(VV), figure(nfig)
 xyx=input(['\n   **** figure ',nfigs,' **** '],'s');
 clc
 disp(' ')
 disp('   DESIGN OF THE REFERENCE PID REGULATOR:')
 disp(' ')
 disp('   1 - the phase margin phm and corresponding angular frequency omm')
 disp('       of the controlled system are computed and displayed;')
 disp('   2 - the required phase margin phd is entered by the user, and the')
 disp('       angular frequency corresponding to phase -180+phd in the')
 disp('       frequency response of the controlled system is derived;')
 disp('   3 - a PID regulator having this as the mid-band frequency and')
 disp('       Ti/Td = 4 is derived;')
 disp('   4 - the phase margin phd for the overall system is obtained')
 disp('       with a suitable choice of Kc.')
 disp(' ')
 disp('   REMARKS:')
 disp(' ')
 disp('   1 - if the plant is type 1 a PD regulator is derived;')
 disp('   2 - hence, dividing the plant transfer function by s before')
 disp('       entering is equivalent to computing a PI regulator with')
 disp('       Kc'' = Kc Td, Ti'' = Td.')
 disp(' ')
 disp('   Interactive adjustment of Ti and Td is possible')
 disp(' ')
%
elseif flag==6 % information on pidd
%
 clc
 disp(' '), disp(' ')
 disp('   PROPORTIONAL-INTEGRAL-DERIVATIVE (PID) DIGITAL REGULATOR')
 disp(' ')
 disp('   The regulator transfer function is:')
 disp(' ')
 disp('                     1  T z      z-1')
 disp('   gc(z) = Kc ( 1 + --- --- + Td --- ) ,')
 disp('                    Ti  z-1      T z')
 disp(' ')
 disp('   where T denotes the sampling time.')
 disp(' ')
 disp('   REMARKS:')
 disp(' ')
 disp('   1 - if the plant is type 1 a PD regulator is derived;')
 disp('   2 - hence, multiplying by (T z)/(z-1) the plant transfer function')
 disp('       before entering is equivalent to computing a PI regulator with')
 disp('       Kc'' = Kc Td, Ti'' = Td.')
 disp(' ')
 disp(' ')
 disp('   **** press any key to continue')
 disp(' ')
 pause
 clc
 disp(' ')
 disp('   Derivative action taken from the feedback path is equivalent to')
 disp('   splitting the regulator into two units:')
 disp(' ')
 disp('   a PI feedforward unit:')
 disp(' ')
 disp('                      1  T z        Ti (z-1) + T z')
 disp('   gcd(z) = Kc ( 1 + --- --- ) = Kc -------------- ;')
 disp('                     Ti  z-1           Ti (z-1)')
 disp(' ')
 disp('   a feedback compensator:')
 disp(' ')
 disp('            Ti Td (z-1)^2 + T z [Ti (z-1) + T z]')
 disp('   gcf(z) = ------------------------------------ .')
 disp('                  T z [Ti (z-1)+ T z]')
 disp(' ')
 disp(' ')
 disp('   **** press any key to continue')
 disp(' ')
 pause
 clc
 disp(' ')
 disp('   DESIGN OF THE REFERENCE PID DIGITAL REGULATOR:')
 disp(' ')
 disp('   The design is performed in the wplane with the same procedure used')
 disp('   in the continuous-time case. Since')
 disp(' ')
 disp('   T z   T w + 2')
 disp('   --- = ------- ,')
 disp('   z-1     2 w')
 disp(' ')
 disp('   the wplane-equivalent regulator is:')
 disp(' ')
 disp('                       1  T w + 2        2 w')
 disp('   gc(w) = Kc * ( 1 + --- ------- + Td ------- ) .')
 disp('                      Ti    2 w        T w + 2')
end
% --- last line of prninfo ---
