function samptime(arg1)
%SAMPTIME Displaying and setting the current sampling time (TFI).
%   Possible uses:
%   SAMPTIME	interactively defines the sampling time of the TFI environment
%   SAMPTIME,T	from TFI [SAMPTIME('T') from Matlab] defines as T the sampling
%		time of the TFI environment.
%   SAMPTIME,gi from TFI [SAMPTIME('gi') from Matlab] displays information
%		on the sampling time of gi if gi is discrete-time.

% TFI Environment (A.Civolani & G.Marro) - 1994-96. Matlab5 version, 1997.

err=0;
if nargin==0
 flg=0;
 while flg==0
  if exist('time#.mat')
   fprintf('\n   the current sampling time is %.4g sec',lsamp)
   Tc=input('\n   enter a new value (default is "no change") : ');
  else
   flg1=0;
   while flg1==0
    Tc=input('\n   sampling time : ');
    if ~isempty(Tc)
     flg1=1;
    end
   end
  end
  if length(Tc)~=0
   if Tc<=0
    disp('   **** illegal sampling time')
   else
    flg=1;
   end
  else
   return
  end
 end
 if Tc<=0
  disp('   **** illegal sampling time')
  return
 else
  fprintf('\n   the current sampling time is %.4g sec\n',Tc)
  eval('save time# Tc -v4')
 end
else
 if ~isstr(arg1), Tc=arg1; eval('save time# Tc -v4'), return, end
 aa=1; Tc=0;
 aa=aa & ~any(arg1=='_');
 aa=aa & ~any(arg1=='(');
 aa=aa & ~any(arg1==')');
 aa=aa & ~any(arg1=='^');
 aa=aa & ~any(arg1=='&');
 aa=aa & ~any(arg1=='#');
 aa=aa & ~any(arg1=='%');
 aa=aa & ~any(arg1=='.');
 aa=aa & ~((abs(arg1(1))>=48)&(abs(arg1(1))<=57));
 if aa
  if ~exist([arg1,'.mat'])
   disp([' **** error: ',arg1,'.mat does not exist']), return
  else
   eval(['load ',arg1])
  end
  if strc=='z'
   fprintf(['\n   the sampling time of ',arg1,'(z) is %.4g sec\n'],Tc)
  else
   fprintf(['\n   transfer function ',arg1,'(s) is continuous-time\n'])
  end
 else
  eval(['Tc=',arg1,';'],'err=1;')
  if Tc<=0
   disp('   **** illegal sampling time')
   return
  else
   eval('save time# Tc -v4','err=1;')
  end
  if err==0, fprintf('\n   the current sampling time is %.4g sec\n',Tc), end
 end
end
% --- last line of samptime ---
