function select(arg1,arg2,arg3,arg4)
%SELECT   Selection of factors from a transfer function (TFI).
%   SELECT,gi,gj - from TFI [SELECT('gi,'gj') - from Matlab] enables
%   interactive selection of factors of gi and saves them in gj.
%   If SELECT is called without arguments, transfer functions gi and gj
%   can be specified in interactive mode.

% TFI Environment (A.Civolani & G.Marro) - 1994-96. Matlab5 version, 1997.

if nargin==0
 gi=input('\n   enter transfer function gi (input) : ','s');
 if isempty(gi), return, end
 if gi=='0', return, end
 if ~exist([gi,'.mat'])
  disp([' **** error: ',gi,'.mat does not exist']), return
 end
 gj=input('\n   enter transfer function gj (output) : ','s');
 if isempty(gj), return, end
 if gj=='0', return, end
elseif nargin>=2
 if ~exist([arg1,'.mat'])
  disp([' **** error: ',arg1,'.mat does not exist']), return
 else
  gi=arg1; gj=arg2;
 end
else
 disp(' **** error: not enough input arguments'), return
end
clc
eval(['load ',gi])
sn=size(Numc); sd=size(Denc); Numc=[zeros(1,sn(2)-1),kc;Numc]; sn(1)=sn(1)+1;
%  Ko : the old dc gain
if strc=='s'
 Ko=Numc(1,sn(2));
 if sn(1)>1
  vvn=Numc(2:sn(1),sn(2)); vvn=vvn(find(vvn~=0));
  for kk=1:length(vvn), Ko=Ko*vvn(kk); end
 end
 vvd=Denc(:,sd(2)); vvd=vvd(find(vvd~=0));
 for kk=1:length(vvd), Ko=Ko/vvd(kk); end
else
 Ko=Numc(1,sn(2));
 if sn(1)>1
  vvn=(sum(Numc(2:sn(1),:)'))'; vvn=vvn(find(vvn~=0));
  for kk=1:length(vvn), Ko=Ko*vvn(kk); end
 end
 vvd=(sum(Denc'))'; vvd=vvd(find(vvd~=0));
 for kk=1:length(vvd), Ko=Ko/vvd(kk); end
end
%
tfg(gi)
disp(' ')
fprintf('   numerator:')
flg=0; Num=1;
while flg==0
 s=input('\n   select factors 1,2,..; * for all; return to skip : ','s');
 if length(s)~=0
  if s=='*'
   Num=Numc; flg=1;
  else
   s=s(find(s~=' '));
   a=zeros(1,sn(1)); x=[]; vect=[]; jj=0;
   for i=1:length(s)
    rop=((abs(s(i))>=49)&(abs(s(i))<=57));
    rop=rop|((abs(s(i))==48)&(length(x)~=0));
    rop=rop|(s(i)==',');
    if rop
     if s(i)~=','
      x=[x,s(i)];
     else
      vect=[vect,eval(x)]; x=[];
     end
    else
     jj=1; break
    end
   end
   if jj==0
    vect=[vect,eval(x)];
    if length(find(vect>sn(1)))==0
     a(vect)=ones(1,length(vect)); flg=1; Num=Numc(find(a),:);
    end
   end
  end
 else
  flg=1;
 end
end
disp(' ')
fprintf('   denominator:')
flg=0; Den=1;
while flg==0
 s=input('\n   select factors 1,2,..; * for all; return to skip : ','s');
 if length(s)~=0
  if s=='*'
   Den=Denc; flg=1;
  else
   s=s(find(s~=' '));
   a=zeros(1,sd(1)); x=[]; vect=[]; jj=0;
   for i=1:length(s)
    rop=((abs(s(i))>=49)&(abs(s(i))<=57));
    rop=rop|((abs(s(i))==48)&(length(x)~=0));
    rop=rop|(s(i)==',');
    if rop
     if s(i)~=','
      x=[x,s(i)];
     else
      vect=[vect,eval(x)]; x=[];
     end
    else
     jj=1; break
    end
   end
   if jj==0
    vect=[vect,eval(x)];
    if length(find(vect>sd(1)))==0
     a(vect)=ones(1,length(vect)); flg=1; Den=Denc(find(a),:);
    end
   end
  end
 else
  flg=1;
 end
end
%
sn=size(Num); sd=size(Den);
%  Kn : the new dc gain
if strc=='s'
 Kn=Num(1,sn(2));
 if sn(1)>1
  vvn=Num(2:sn(1),sn(2)); vvn=vvn(find(vvn~=0));
  for kk=1:length(vvn), Kn=Kn*vvn(kk); end
 end
 vvd=Den(:,sd(2)); vvd=vvd(find(vvd~=0));
 for kk=1:length(vvd), Kn=Kn/vvd(kk); end
else
 Kn=Num(1,sn(2));
 if sn(1)>1
  vvn=(sum(Num(2:sn(1),:)'))'; vvn=vvn(find(vvn~=0));
  for kk=1:length(vvn), Kn=Kn*vvn(kk); end
 end
 vvd=(sum(Den'))'; vvd=vvd(find(vvd~=0));
 for kk=1:length(vvd), Kn=Kn/vvd(kk); end
end
%
disp(' ')
mess=['   the dc gain of the original transfer function (',gi,') is: '];
fprintf([mess,'%.4g\n'],Ko)
mess=['   the dc gain of the selected transfer function (',gj,') is: '];
fprintf([mess,'%.4g\n'],Kn)
flg=0;
while (flg~=1)&(flg~=2)&(flg~=3)
 disp(' ')
 disp('   1 - maintain the dc gain of the original transfer function')
 disp('   2 - maintain the dc gain of the selected transfer function')
 disp('   3 - specify a new dc gain')
 flg=input('\n   your choice : ');
 if length(flg)==0, flg=0; end
end
K=1;
if flg==1
 K=Ko/Kn;
elseif flg==3
 gain=input('\n   enter the new value, press return to skip : ');
 if length(gain)~=0
  K=gain/Kn;
 end
end
aa=stf(Num,Den,K,strc,gj);
if aa==1, tfg(gj), end
% --- last line of select ---
