function out1=startint(arg1)
%STARTINT Setting of some options for the TFI environment (TFI).
%   STARTINT can be invoked from Matlab or TFI for interactive selection
%   of TFI settigs. The selected options are saved to file set_tfi7.mat
%   in the work directories of both Matlab and TFI.

%   STARTINT(1) is run when entering TFI environment.
%   STARTINT(2) is run when quitting TFI environment.

% TFI Environment (A.Civolani & G.Marro) - 1994-96. Matlab5 version, 1997. 
% Revised 22/05/2014.

nargs=nargin; err=0; flg=0;
mmm=' **** press any key to continue';
colbg=get(0,'DefaultAxesColor');
if nargs==0, arg1=3; end
if (nargs==1)&(arg1==1)
%
% some TFI settings
%
 POS=get(0,'DefaultFigurePosition');
 VVFULL=get(0,'ScreenSize'); % VVFULL is a [1 times 4] matrix
 XL=VVFULL(3); YL=VVFULL(4); XS=229; YS=137; % small figure size
 VVS=round([XL*.92-XS,YL-YS-50,XS,YS]);
 set(0,'DefaultFigurePosition',VVS)
 set(0,'DefaultTextFontName','Helvetica')
 set(0,'DefaultTextFontSize',10)
 set(0,'DefaultTextFontWeight','normal')
 set(0,'DefaultAxesFontName','Helvetica')
 set(0,'DefaultAxesFontSize',10)
 set(0,'DefaultAxesFontWeight','normal')
 set(0,'DefaultUIControlFontName','MS Sans Serif')
 set(0,'DefaultUIControlFontSize',8)
 set(0,'DefaultUIControlFontWeight','bold')
 vv=version;
 if strcmp(vv(1:3),'5.3')|(str2num(vv(1))>=6)
  set(0,'DefaultFigureTool','none')
 end
 close all
%
% the following lines change directory and/or path when tfi is entered
%
 diro=cd; dirn=diro; patho=path; pathn=[]; legen=0; ispath=0; bgkkk=1; mfig=0;
 if exist('set_tfi7.mat')
  load set_tfi7
  if colbg(1)~=bgkkk, whitebg, end
  s1=cd; flg=1; patho=path;
  pathf=[patho,';'];
  if ispath
   for kk=1:(length(pathf)-5)
    stt=pathf(kk:kk+5);
    if stt(1:5)=='\intp'
     if stt(6)==';'
      ddd1='\intp';
     else
      ddd1=['\intp',stt(6)];
     end
     break
    end
   end
   pathf=pathn;
   ii=find(pathf=='\'); iif=ii(length(ii));
   pathn=[pathf(1:iif-1),ddd1];
  else
   pathn=[];
  end
  aa=abs([s1(1),diro(1),dirn(1)]);
  if aa(3)==92, aa(3)=aa(1); dirn=[s1(1),':',dirn]; end
  ii=find(aa<97);
  if ~isempty(ii), aa(ii)=aa(ii)+32*ones(1,length(ii)); end
  aa=setstr(aa);
  if aa(1)~=aa(2)
   delete set_tfi7.mat
   diro=cd; dirn=diro; pathn=[]; legen=0; ispath=0;
   disp(' ')
   disp('   **** illegal disk unit !')
   disp('   **** the TFI default setting is restored')
  end
  cmp1=cap2sma(s1); cmp2=cap2sma(diro); cmp3=cap2sma(dirn);
  if (~strcmp(cmp1,cmp2))&(~strcmp(cmp1,cmp3))
  flg=0;
   disp(' ')
   disp('   **** the Matlab work directory was changed !')
  end
 else % if exist
  whitebg([1,1,1]) % the default initial color (white) %%%%
  bgkkk=1; flg=1;
  disp(' '), fltt=0; 
  while fltt==0
   disp(' **** file set_tfi7.mat has not been found')
   disp(['      the current work directory is : ',cd])
   fprintf('      do you want to confirm this as a directory')
   xyx=input('\n      from which TFI is invoked ? (1/0) : ');
   if ~isempty(xyx), fltt=1; end
  end
  if xyx~=1, out1=1; return, end
 end
 if exist('legend.m'), islegen=1; else, islegen=0; end
 if flg==1
  save set_tfi7 diro dirn patho pathn legen islegen ispath bgkkk POS mfig -v4
 end
 eval(['cd ',dirn],'err=1;')
 if err==0
  dirn=cd;
  save set_tfi7 diro dirn patho pathn legen islegen ispath bgkkk POS mfig -v4
 end
 if mfig==0, eval('resfiglo'), end
 save legen# legen islegen -v4
 if ispath, path(pathn), end
 disp(' ')
 disp('   INFORMATION ON THE TFI ENVIRONMENT :')
 disp(' ')
 disp(['   the Matlab work directory is ',diro])
 disp(['   the TFI work directory is    ',dirn])
 if err==1
  disp(' ')
  disp('   **** illegal TFI work directory !')
  disp('   **** the TFI default setting is restored')
  diro=cd; dirn=diro; patho=path; pathn=[]; legen=0; ispath=0;
  save set_tfi7 diro dirn patho pathn legen islegen ispath bgkkk POS mfig -v4
 else
  if ispath==0, ll='NOT '; else, ll=''; end
  disp(['   the matlabpath IS ',ll,'REDUCED'])
  if bgkkk==1, ll='WHITE'; else, ll='BLACK'; end
  disp(['   the figure background IS ',ll])
  if mfig==0, ll=' NOT '; else, ll=' '; end
  disp(['   the figure locations ARE',ll,'PERMANENTLY STORED'])
  if exist('legend.m')
   if legen==1, ll=''; else, ll='NOT '; end
   disp(['   legend in figures IS ',ll,'ACTIVATED'])
  end
  disp(' ')
  disp('   use "startint" from TFI to change the TFI environment')
 end
 disp(' '), disp(mmm), pause
 if ~exist('time#.mat'), samptime(.1), end
 if ~exist('figlo#.mat'), resfiglo, end
%
% the following lines restore directory and/or path when tfi is quitted
%
elseif (nargs==1)&(arg1==2)
 set(0,'DefaultUiControlUnits','pixel')
 vv=version;
 if strcmp(vv(1:3),'5.3')|strcmp(vv(1),'6')
  set(0,'DefaultFigureTool','auto')
 end
 if exist('set_tfi7.mat')
  load set_tfi7
  set(0,'DefaultFigurePosition',POS)
  % eval(['cd ',diro],'err=1;')
  eval(['cd ',dirn],'err=1;') % mod. December 2014
  if err==0
   disp(' ')
   disp(['   the Matlab work directory has been restored: ',cd])
   save set_tfi7 diro dirn patho pathn legen islegen ispath bgkkk POS mfig -v4
  else
   delete set_tfi7.mat
  end
  if ispath==1
   path(patho)
   % path(pathn) % mod. December 2014
   disp(' ')
   disp('   the full matlabpath has been restored')
  end
 end
end
%
% interactive selection of directory, path, and legend
%
if arg1==3
 if exist('set_tfi7.mat')
  load set_tfi7
  disp(' ')
  disp(['   TFI was called from and will exit to ',diro])
  disp(['   at present the TFI work directory is ',dirn])
  flg=0;
  while flg==0
   err=0;
   fprintf('   to change the TFI work directory enter its path')
   mess='\n   (default "no change") : ';
   dd=input(mess,'s');
   if isempty(dd)
    flg=1;
   else
    dirt=dd;
    eval(['cd ',dirt],'err=1;')
    if err==1
     disp('   the directory does not exist')
    else
     flg=1; dirn=cd;
    end % if err
   end % if length
  end % while
  disp(' ')
  fprintf('   you can reduce the matlabpath to avoid possible conflict')
  fprintf(' of names\n')
  fprintf('   with new toolboxes;')
  if ispath==0, ll='NOT '; else, ll=''; end
  fprintf([' now the matlabpath IS ',ll,'REDUCED'])
  rl=0;
  while rl==0
   mess='\n   do you want to reduce the matlabpath ? (1/0, ';
   mess=[mess,'default "no change") : '];
   dd=input(mess);
   if isempty(dd), dd=20; rl=1; end
   if (dd==0)|(dd==1), rl=1; end
  end
  if length(dd)==1, flg=dd; else, flg=3; end
  if flg==1
%
% the following lines set the matlabpath when the interpreter is invoked
% ---> list here the names of the needed toolboxes
%
   bb1='\general';
   bb2='\ops';
   bb3='\lang';
   bb4='\elmat';
   bb5='\elfun';
   bb6='\specfun';
   bb7='\matfun';
   bb8='\datafun';
   bb9='\polyfun';
   bb10='\sparfun';
   bb11='\graph2d';
   bb12='\graph3d';
   bb13='\specgraph';
   bb14='\graphics';
   bb15='\uitools';
   bb16='\strfun';
   bb17='\iofun';
   bb18='\timefun';
   bb19='\datatypes';
   bb20='\local';
   bb21='\codetools';
   bb22='\strfun';
   bb23='\scribe';
   bb24='\helptools';
%
   bb25='\intp';
%
   pathf=patho;
   if ~strcmp(pathf(length(pathf)),';'), pathf=[pathf,';']; end
   ii=find(pathf==';');
   rr=0;
   nbox=0;
   while rr==0
    nbox=nbox+1;
    if ~exist(['bb',int2str(nbox)])
     rr=1; nbox=nbox-1;
    end
   end % while rr
%   intt=pathf(1:ii(1)); pathn=intt;
   pathn=[];
   for hh=1:nbox
    bb=eval(['bb',int2str(hh)]);
    rr=0;
    for kk=1:length(ii)
     cc=pathf((ii(kk)-length(bb)):(ii(kk)-1));
     if strcmp(bb,'\intp')
      cc1=pathf((ii(kk)-length(bb)-1):(ii(kk)-1));
      cc1=cc1(1:length(bb));
     else
      cc1='xxx';
     end
     if strcmp(cc,bb)|strcmp(cc1,bb)
      if kk==1, ind1=1; else, ind1=ii(kk-1)+1; end
      aa=pathf(ind1:ii(kk)); pathn=[pathn,aa]; rr=1; break
     end
    end % for kk
   end % for hh
   disp(' ')
   if rr==0
    disp(['   toolbox ',bb,' has not been found in the matlabpath;'])
    disp('   check the directory list in file startint.m')
    disp(' '), disp(mmm), pause
    pathn=[]; ispath=0;
   else
    fprintf('   the matlabpath has been reduced to avoid conflict of names')
    fprintf(' with new\n')
    fprintf('   toolboxes; it will been restored when quitting TFI\n')
    path(pathn), ispath=1;
   end
  elseif flg==0
   path(patho), pathn=[]; ispath=0;
  end % if flg
  disp(' ')
  if bgkkk==1, ll='WHITE'; else, ll='BLACK'; end
  fprintf(['   the figure background IS ',ll,])
  rl=0;
  while rl==0
   mess='\n   black or white figure background ? ';
   mess=[mess,'(1/0, default "no change") : '];
   dd=input(mess);
   if isempty(dd), dd=20; rl=1; end
   if (dd==0)|(dd==1), bgkkk=~dd; rl=1; end
  end
  whitebg([1 1 1]*(bgkkk)) 
  disp(' ')
  if mfig==1, ll=''; else, ll='NOT '; end
  fprintf(['   the figure locations ARE ',ll,'STORED'])
  fprintf(' for next TFI sessions')
  rl=0;
  while rl==0
   mess='\n   do you want to store them ? ';
   mess=[mess,'(1/0, default "no change") : '];
   dd=input(mess);
   if isempty(dd), dd=20; rl=1; end
   if (dd==0)|(dd==1), mfig=dd; rl=1; end
  end
  if exist('legend.m')
   disp(' ')
   if legen==1, ll=''; else, ll='NOT '; end
   fprintf(['   legend in figures IS ',ll,'ACTIVATED'])
   rl=0;
   while rl==0
    mess='\n   do you want legend in figures ? ';
    mess=[mess,'(1/0, default "no change") : '];
    dd=input(mess);
    if isempty(dd), dd=20; rl=1; end
    if (dd==0)|(dd==1), legen=dd; rl=1; end
   end
  end % if exist('legend.m')
  save legen# legen islegen -v4
  save set_tfi7 diro dirn patho pathn legen islegen ispath bgkkk POS mfig -v4
  if ~exist('time#.mat')
   eval('samptime')
  end
  if ~strcmp(diro,dirn)
   dircurr=cd;
   if ~strcmp(dircurr,diro)
    err=0; eval(['cd ',diro],'err=1;')
    if err==0
     save set_tfi7 diro dirn patho pathn legen islegen ispath bgkkk POS mfig -v4
    end
   elseif ~strcmp(dircurr,dirn)
    err=0; eval(['cd ',dirn],'err=1;')
    if err==0
     save set_tfi7 diro dirn patho pathn legen islegen ispath bgkkk POS mfig -v4
    end
   end
   eval(['cd ',dircurr],'err=1;')
  end
 else
  disp(' ')
  disp('   the file set_tfi7.mat does not exist')
  disp('   exit TFI and enter again to introduce the default settings')
  disp('   then run "startint"')
  disp(' ')
 end % if exist('set_tfi7.mat')
end % if arg1
if nargs~=0, out1=0; end
%
function as=cap2sma(bs)
cs=abs(bs); ii=find((cs>=65)&(cs<=90)); cs(ii)=cs(ii)+32; as=setstr(cs);
%
% ----- last line of startint -----
