function samptime(arg1)
%SAMPTIME Definizione e visualizzazione del tempo di campionamento (TFI).
%   Possibili impieghi:
%   SAMPTIME	definizione interattiva del tempo di campionamento di TFI
%   SAMPTIME,T	da TFI [SAMPTIME('T') da Matlab] definisce come T il tempo
%		di campionamento dell'ambiente TFI.
%   SAMPTIME,gi da TFI [SAMPTIME('gi') da Matlab] mostra il tempo di
%		campionamento di gi se gi e' a tempo discreto.

% TFI Environment (A.Civolani & G.Marro) - 1994-96. Matlab5 version, 1997.

err=0; eA=setstr(232);
if nargin==0
 flg=0;
 while flg==0
  if exist('time#.mat')
   fprintf(['\n   il tempo di campionamento attuale ',eA,' %.4g sec'],lsamp)
   Tc=input('\n   specificare un nuovo valore (default "non cambiare") : ');
  else
   flg1=0;
   while flg1==0
    Tc=input('\n   tempo di campionamento : ');
    if ~isempty(Tc)
     flg1=1;
    end
   end
  end
  if length(Tc)~=0
   if Tc<=0
    disp('   **** tempo di campionamento non valido')
   else
    flg=1;
   end
  else
   return
  end
 end
 if Tc<=0
  disp('   **** tempo di campionamento non valido')
  return
 else
  fprintf(['\n   il tempo di campionamento attuale ',eA,' %.4g sec\n'],Tc)
  eval('save time# Tc -v4')
 end
else
 if ~isstr(arg1), Tc=arg1; eval('save time# Tc -v4'), return, end
 aa=1; Tc=0;
 aa=aa & ~any(arg1=='_');
 aa=aa & ~any(arg1=='(');
 aa=aa & ~any(arg1==')');
 aa=aa & ~any(arg1=='^');
 aa=aa & ~any(arg1=='&');
 aa=aa & ~any(arg1=='#');
 aa=aa & ~any(arg1=='%');
 aa=aa & ~any(arg1=='.');
 aa=aa & ~((abs(arg1(1))>=48)&(abs(arg1(1))<=57));
 if aa
  if ~exist([arg1,'.mat'])
   disp([' **** error: ',arg1,'.mat non esiste']), return
  else
   eval(['load ',arg1])
  end
  if strc=='z'
   fprintf(['\n   il tempo di campionamento di ',arg1,'(z) ',eA,...
   ' %.4g sec\n'],Tc)
  else
   fprintf(['\n   la funzione di trasferimento ',arg1,'(s) ',eA,...
   ' a tempo continuo\n'])
  end
 else
  eval(['Tc=',arg1,';'],'err=1;')
  if Tc<=0
   disp('   **** tempo di campionamento non valido')
   return
  else
   eval('save time# Tc -v4','err=1;')
  end
  if err==0
   fprintf(['\n   il tempo di campionamento attuale ',eA,' %.4g sec\n'],Tc)
  end
 end
end
% --- last line of samptime ---
